// WL_INTER.C

#include "wl_def.h"
#pragma hdrstop

LRstruct LevelRatios[LRpack];
int32_t lastBreathTime = 0;

void Write (int x, int y, const char *string);

//==========================================================================

/*
==================
=
= CLearSplitVWB
=
==================
*/

void
ClearSplitVWB (void)
{
    WindowX = 0;
    WindowY = 0;
    WindowW = 320;
    WindowH = 160;
}

//==========================================================================

/*
==================
=
= Victory
=
==================
*/

void Victory (void) {
    int32_t sec;
    int i, min, kr, sr, tr, x;
    char tempstr[8];

#define RATIOX  224
#define RATIOY  112
#define TIMEX   184
#define TIMEY   72

    StartCPMusic (D_VICTOR_MUS);
    ClearSplitVWB ();
    CA_CacheGrChunk(BACKDROPPIC);
    VWB_DrawPic(0, 0, BACKDROPPIC);
    CacheLump (LEVELEND_LUMP_START, LEVELEND_LUMP_END);
    CacheLump (INTERMISSION_LUMP_START, INTERMISSION_LUMP_END);
    CA_CacheGrChunk (STARTFONT);
    
    for (kr = sr = tr = sec = i = 0; i < LRpack; i++)
    {
        sec += LevelRatios[i].time;
        kr += LevelRatios[i].kill;
        sr += LevelRatios[i].secret;
        tr += LevelRatios[i].treasure;
    }

    if (gamestate.episode != 3) {
        kr /= LRpack;
        sr /= LRpack;
        tr /= LRpack;
    } else {
        // Level 9 is not counted in the final episode
        kr /= LRpack - 1;
        sr /= LRpack - 1;
        tr /= LRpack - 1;
    }

    min = sec / 60;
    sec %= 60;

    if (min > 99)
        min = sec = 99;

    VWB_DrawPic(112, 32, YOUWINPIC);

    VWB_DrawPic(TIMEX - 112, TIMEY, AVERAGEPIC); 

    i = TIMEX;
    VWB_DrawPic (i, TIMEY, L_NUM0PIC + (min / 10));
    i += 12;
    VWB_DrawPic (i, TIMEY, L_NUM0PIC + (min % 10));
    i += 12;
    Write (i, TIMEY, ":");
    i += 6;
    VWB_DrawPic (i, TIMEY, L_NUM0PIC + (sec / 10));
    i += 12;
    VWB_DrawPic (i, TIMEY, L_NUM0PIC + (sec % 10));
    VW_UpdateScreen ();

    itoa (kr, tempstr, 10);
    x = RATIOX - (int) strlen(tempstr) * 12;
    Write (x, RATIOY, tempstr);
    VWB_DrawPic(64, RATIOY, KILLSPIC);
    Write (RATIOX, RATIOY, "%");

    itoa (sr, tempstr, 10);
    x = RATIOX - (int) strlen(tempstr) * 12;
    Write (x, RATIOY + (1 * 14), tempstr);
    VWB_DrawPic(64, RATIOY + (1 * 14), SECRETPIC);
    Write (RATIOX, RATIOY + (1 * 14), "%");

    itoa (tr, tempstr, 10);
    x = RATIOX - (int) strlen(tempstr) * 12;
    Write (x, RATIOY + (2 * 14), tempstr);
    VWB_DrawPic(64, RATIOY + (2 * 14), ITEMSPIC);
    Write (RATIOX, RATIOY + (2 * 14), "%");

    fontnumber = 1;

    VW_UpdateScreen ();
    VW_FadeIn ();

    IN_Ack ();

    VW_FadeOut ();
    if(screenHeight % 200 != 0)
        VL_ClearScreen(0);

    UNCACHEGRCHUNK(BACKDROPPIC);
    UnCacheLump (LEVELEND_LUMP_START, LEVELEND_LUMP_END);
    UnCacheLump (INTERMISSION_LUMP_START, INTERMISSION_LUMP_END);
}

void EndScrollText()
{
    const char *endStrings[NUMEPISODES] = { EPISODE1STR, EPISODE2STR, EPISODE3STR, EPISODE4STR };

    CacheLump(MESSAGE_LUMP_START, MESSAGE_LUMP_END);
    CA_CacheGrChunk(BACKDROPPIC);

    VWB_DrawPic (0,0, BACKDROPPIC);

    VW_FadeIn();

    // offset by 32
    static const int alpha[] =
    {
        0,0,0,0,0,0,0,0,
        0,0,0,0,0,0,0,0,
        0,0,0,0,0,0,0,0,
        0,0,0,0,0,0,0,0,
        0, STCFN033, STCFN034, STCFN035, STCFN036, STCFN037, STCFN038, STCFN039,
        STCFN040, STCFN041, STCFN042, STCFN043, STCFN044, STCFN045, STCFN046, STCFN047,
        STCFN048, STCFN049, STCFN050, STCFN051, STCFN052, STCFN053, STCFN054, STCFN055,
        STCFN056, STCFN057, STCFN058, STCFN059, STCFN060, STCFN061, STCFN062, STCFN063,
        STCFN064, STCFN065, STCFN066, STCFN067, STCFN068, STCFN069, STCFN070, STCFN071,
        STCFN072, STCFN073, STCFN074, STCFN075, STCFN076, STCFN077, STCFN078, STCFN079,
        STCFN080, STCFN081, STCFN082, STCFN083, STCFN084, STCFN085, STCFN086, STCFN087,
        STCFN088, STCFN089, STCFN090, STCFN091, STCFN092, STCFN093, STCFN094, STCFN095,
        STCFN039, STCFN065, STCFN066, STCFN067, STCFN068, STCFN069, STCFN070, STCFN071,
        STCFN072, STCFN073, STCFN074, STCFN075, STCFN076, STCFN077, STCFN078, STCFN079,
        STCFN080, STCFN081, STCFN082, STCFN083, STCFN084, STCFN085, STCFN086, STCFN087,
        STCFN088, STCFN089, STCFN090, 0, STCFN121, 0, 0, 0
    };

    const char* string = endStrings[gamestate.episode];

    int i, ox, nx, ny, len = (int) strlen(string);
    char ch;

    ox = nx = 4;
    ny = 4;
    bool finish = false;
    IN_StartAck ();
    for (i = 0; i <= len; i++)
    {
        if (string[i] == '\n')
        {
            nx = ox;
            ny += 8;
        }
        else
        {
            ch = string[i];
        //	if (ch >= 'a')
        //		ch -= ('a' - 'A');
        //	ch -= '0';

            switch (ch)
            { 
            case '\n':
                nx = ox;
                ny += 8;
                break;
                case '!':
                    VWB_DrawPic (nx, ny, STCFN033);
                    nx+=4;
                    continue;
                case '\"':
                    VWB_DrawPic (nx,ny, STCFN034);
                    nx+=8;
                    continue;
                case '#':
                    VWB_DrawPic (nx,ny,STCFN035);
                    nx+=8;
                    continue;
                case '$':
                    VWB_DrawPic (nx,ny, STCFN036);
                    nx+=8;
                    continue;
                case '%':
                    VWB_DrawPic (nx,ny,STCFN037);
                    nx+=9;
                    continue;
                case '&':
                    VWB_DrawPic (nx,ny, STCFN038);
                    nx+=8;
                    continue;
                case ',':
                    VWB_DrawPic (nx,ny+4,STCFN039);
                    nx+=4;
                    continue;
                case '(':
                    VWB_DrawPic (nx,ny,STCFN040);
                    nx+=8;
                    continue;
                case ')':
                    VWB_DrawPic (nx,ny,STCFN041);
                    nx+=8;
                    continue;
                case '*':
                    VWB_DrawPic (nx,ny,STCFN042);
                    nx+=8;
                    continue;
                case '+':
                    VWB_DrawPic (nx,ny,STCFN043);
                    nx+=5;
                    continue;
                case 0x27: // apostrophe
                case 0x60: // ` back apo
                    VWB_DrawPic (nx, ny,STCFN044);
                    nx+=4;
                    continue;
                case '-':
                    VWB_DrawPic (nx,ny+2,STCFN045);
                    nx+=8;
                    continue;
                case '.':
                    VWB_DrawPic (nx,ny+4,STCFN046);
                    nx+=4;
                    continue;
                case '/':
                    VWB_DrawPic (nx,ny,STCFN047);
                    nx+=8;
                    continue;
                case '1':
                    VWB_DrawPic (nx, ny,STCFN049);
                    nx+=5;
                    continue;
                case 0x3a:     // ':'
                    VWB_DrawPic (nx,ny,STCFN058);
                    nx+=4;
                    continue;
                case ';':
                    VWB_DrawPic (nx,ny,STCFN059);
                    nx+=4;
                    continue;
                case '<':
                    VWB_DrawPic (nx,ny,STCFN060);
                    nx+=8;
                    continue;
                case '=':
                    VWB_DrawPic (nx,ny,STCFN061);
                    nx+=8;
                    continue;
                case '>':
                    VWB_DrawPic (nx,ny,STCFN062);
                    nx+=8;
                    continue;
                case '?':
                    VWB_DrawPic (nx,ny,STCFN063);
                    nx+=8;
                    continue;
                case '@':
                    VWB_DrawPic (nx,ny,STCFN064);
                    nx+=9;
                    continue;
                case 'i':
                case 'I':
                    VWB_DrawPic (nx,ny,STCFN073);
                    nx+=4;
                    continue;
                case 'm':
                case 'M':
                    VWB_DrawPic (nx,ny,STCFN077);
                    nx+=9;
                    continue;
                case 's':
                case 'S':
                    VWB_DrawPic (nx,ny,STCFN083);
                    nx+=7;
                    continue;
                case 'v':
                case 'V':
                    VWB_DrawPic (nx,ny,STCFN086);
                    nx+=7;
                    continue;
                case 'w':
                case 'W':
                    VWB_DrawPic (nx,ny,STCFN087);
                    nx+=9;
                    continue;
                case 'x':
                case 'X':
                    VWB_DrawPic (nx,ny,STCFN088);
                    nx+=9;
                    continue;
                case 'z':
                case 'Z':
                    VWB_DrawPic (nx,ny, STCFN090);
                    nx+=7;
                    continue;
                case ' ':
                    nx+=4;
                    break;
                case '[':
                    VWB_DrawPic (nx,ny,STCFN091);
                    nx+=5;
                    continue;
                case '\\':
                    VWB_DrawPic (nx,ny,STCFN092);
                    nx+=8;
                    continue;
                case ']':
                    VWB_DrawPic (nx,ny,STCFN093);
                    nx+=5;
                    continue;
                case '^':
                    VWB_DrawPic (nx,ny,STCFN094);
                    nx+=8;
                    continue;
                case '_':
                    VWB_DrawPic (nx,ny+4,STCFN095);
                    nx+=8;
                    continue;
                case '|':
                    VWB_DrawPic (nx,ny,STCFN121);
                    nx+=4;
                    continue;
                default:
                    VWB_DrawPic (nx,ny,alpha[ch]);
                    nx+=8;
                    break;
            }
        }
        VW_UpdateScreen();
        if (!finish) {
            if (IN_CheckAck()) {
                finish = true;
            }

            VW_WaitVBL (10);
        }

    }

    VW_WaitVBL (5*70);

    VW_FadeOut ();
    UNCACHEGRCHUNK(BACKDROPPIC);
    UnCacheLump(MESSAGE_LUMP_START, MESSAGE_LUMP_END);
}

//==========================================================================

/*
==================
=
= PG13
=
==================
*/

void PG13 (void)
{
    VW_FadeOut ();
    VWB_Bar (0, 0, 320, 200, 0x00);     // background

    CA_CacheGrChunk (CILOGOPIC);
    VWB_DrawPic (96, 67, CILOGOPIC);
    VW_UpdateScreen ();
    
    UNCACHEGRCHUNK (CILOGOPIC);

    VW_FadeIn ();
    IN_UserInput (TickBase * 7);

    VW_FadeOut ();
}


//==========================================================================

void Write (int x, int y, const char *string)
{
    static const int alpha[] = { L_NUM0PIC,L_NUM1PIC,L_NUM2PIC,L_NUM3PIC,L_NUM4PIC,L_NUM5PIC,
    L_NUM6PIC,L_NUM7PIC,L_NUM8PIC,L_NUM9PIC,L_COLONPIC };

    int i, len = (int) strlen(string);
    char ch;

    for (i = 0; i < len; i++)
    {
        if (string[i] == '\n')
        {
            y += 12;
        }
        else
        {
            ch = string[i];
            if (ch >= 'a')
                ch -= ('a' - 'A');
            ch -= '0';

            switch (string[i])
            {
                case ' ':
                    break;

                case 0x3a:     // ':'
                    VWB_DrawPic (x, y+1, L_COLONPIC);
                    x += 5;
                    continue;

                case '%':
                    VWB_DrawPic (x, y, L_PERCENTPIC);
                    x+=13;
                    break;

                default:
                    VWB_DrawPic (x, y, alpha[ch]);
            }
            x += 11;
        }
    }
}


void BJ_Breathe (void)
{
    SDL_Delay(5);
}



/*
==================
=
= LevelCompleted
=
= Entered with the screen faded out
= Still in split screen mode with the status bar
=
= Exit with the screen faded out
=
==================
*/

void LevelCompleted (void) {
#define VBLWAIT 30
#define VBLPAUSE 10
#define BONUSSOUNDLEAPS 10
#define STATSSOUNDLEAPS 4
#define PAR_AMOUNT      500
#define PERCENT100AMT   10000
    typedef struct {
        float time;
        char timestr[6];
    } times;

    int x, i, min, sec, tmin, tsec, ratio, kr, sr, tr;
    char tempstr[10];
    int32_t bonus, timeleft = 0;
    times parTimes[] = {
     {1.5,	"1:30"}, // complete 8-12-2012
     {2,	"2:00"}, // complete 9/29/2012
     {2,	"2:00"}, // complete 9/29/2012
     {5.5,	"5:30"}, // complete 9/29/2012
     {2.5,	"2:30"}, // complete 9/29/2012
     {2.75,	"2:45"}, // complete 9/29/2012
     {3.5,	"3:30"}, // complete 10/1/2012
     {2,	"2:00"}, // complete 10/1/2012
     {1.5,	"1:30"}, // complete 10/21/2012
     {2.75,	"2:45"}, // complete 10/20/2012

     {2,	"2:00"}, // complete 10/25/2012
     {3.25,	"3:15"}, // complete 10/27/2012
     {2.5,	"2:30"}, // complete 11/1/2012
     {2,	"2:00"}, // complete 11/4/2012
     {3.25,	"3:15"}, // complete 11/6/2012
     {2.25,	"2:15"}, // complete 11/11/2012
     {3.5,	"3:30"}, // complete 11/11/2012
     {3.5,	"3:30"}, // complete 11/11/2012
     {1,	"1:00"}, // complete 10/13/2012
     {2.25,	"2:15"}, // complete 11/4/2012

     {2.25,	"2:15"}, // complete 11/13/2012
     {3.25,	"3:15"}, // complete 11/15/2012
     {2.25,	"2:15"}, // complete 11/16/2012
     {2.25,	"2:15"}, // complete 11/18/2012
     {2.5,	"2:30"}, // complete 11/19/2012
     {2,	"2:00"}, // complete 11/20/2012
     {1.5,	"1:30"}, // complete 11/25/2012
     {1.75,	"1:45"}, // complete 11/26/2012
     {0.5,	"0:30"}, // complete 11/30/2012
     {2.5,	"2:30"}, // complete 11/30/2012

     {2.75,	"2:45"}, // complete 12/1/2012
     {1.25,	"1:15"}, // complete 12/1/2012
     {2.25,	"2:15"}, // complete 12/2/2012
     {3,	"3:00"}, // complete 12/3/2012
     {2.25,	"2:15"}, // complete 12/4/2012
     {1.75,	"1:45"}, // complete 12/5/2012
     {2,	"2:00"}, // complete 12/6/2012
     {1.15,	"1:15"}, // complete 12/8/2012
     {0,	"??:??"},
     {0.75,	"0:45"}, // complete 12/3/2012
     {0,	"??:??"}
    };
    
    CacheLump(LEVELEND_LUMP_START,LEVELEND_LUMP_END);
    CacheLump(INTERMISSION_LUMP_START,INTERMISSION_LUMP_END);
    CA_CacheGrChunk (FINISHEDPIC);
    CA_CacheGrChunk (BACKDROPPIC);
    ClearSplitVWB ();           // set up for double buffering in split screen
    
    VWB_Bar (0,0,320,200-STATUSLINES,0);
    StartCPMusic (D_MMENU_MUS);
    
    byte *source = grsegs[BACKDROPPIC];
    VWB_DrawPic (0,0,BACKDROPPIC);
    int picnum = E1M1PIC-STARTPICS+gamestate.episode*10+mapon;
    int width = pictable[picnum].width;
    CA_CacheGrChunk(picnum+STARTPICS);
    VWB_DrawPic((320-width)/2,6,picnum+STARTPICS);
    VWB_DrawPic (114,20,FINISHEDPIC);
    
    VWB_DrawPic (50,50,KILLSPIC);
    VWB_DrawPic (50,68,ITEMSPIC);
    VWB_DrawPic (50,86,SECRETPIC);
    VWB_DrawPic (270,50,L_PERCENTPIC);
    VWB_DrawPic (270,68,L_PERCENTPIC);
    VWB_DrawPic (270,86,L_PERCENTPIC);
    VWB_DrawPic (50,104,BONUSPIC);
    VWB_DrawPic (176,168,PARPIC);
    VWB_DrawPic (16,168,TIMEPIC);
    Write (255,168,parTimes[gamestate.episode*10+mapon].timestr);
//
// do the intermission
//
    IN_ClearKeysDown ();
    IN_StartAck ();

        //
        // PRINT TIME
        //
        sec = gamestate.TimeCount / 70;

        if (sec > 99 * 60)      // 99 minutes max
            sec = 99 * 60;

        if (gamestate.TimeCount < parTimes[gamestate.episode * 10 + mapon].time * 4200)
            timeleft = (int32_t) ((parTimes[gamestate.episode * 10 + mapon].time * 4200) / 70 - sec);

        min = sec / 60;
        sec %= 60;
        
        i = 95;
        VWB_DrawPic (i,168, L_NUM0PIC + (min / 10));
        i += 11;
        VWB_DrawPic (i,168, L_NUM0PIC + (min % 10));
        i += 11;
        Write (i,168, ":");
        i += 5;
        VWB_DrawPic (i,168, L_NUM0PIC + (sec / 10));
        i += 11;
        VWB_DrawPic (i,168, L_NUM0PIC + (sec % 10));

        
        //
        // PRINT TOTAL TIME
        //
        for (tsec = i = 0; i < LRpack; i++)
        {
            tsec += LevelRatios[i].time;
        }

            tsec += min * 60 + sec; // adds current level time

        tmin = tsec / 60;
        tsec %= 60;

        i = 95;
        VWB_DrawPic (i,184, L_NUM0PIC + (tmin / 10));
        i += 11;
        VWB_DrawPic (i,184, L_NUM0PIC + (tmin % 10));
        i += 11;
        Write (i,184, ":");
        i += 5;
        VWB_DrawPic (i,184, L_NUM0PIC + (tsec / 10));
        i += 11;
        VWB_DrawPic (i,184, L_NUM0PIC + (tsec % 10));

        VW_UpdateScreen ();
        VW_FadeIn ();


        //
        // FIGURE RATIOS OUT BEFOREHAND
        //
        kr = sr = tr = 0;
        if (gamestate.killtotal)
            kr = (gamestate.killcount * 100) / gamestate.killtotal;
        if (gamestate.secrettotal)
            sr = (gamestate.secretcount * 100) / gamestate.secrettotal;
        if (gamestate.treasuretotal)
            tr = (gamestate.treasurecount * 100) / gamestate.treasuretotal;

#define RATIOXX                268
        //
        // PRINT TIME BONUS
        //
        bonus = timeleft * PAR_AMOUNT;
        if (bonus)
        {
            for (i = 0; i <= timeleft; i++)
            {
                ltoa ((int32_t) i * PAR_AMOUNT, tempstr, 10);
                x = RATIOXX - (int) strlen(tempstr) * 11;
                VL_MemToScreenScaledCoord (source,320,200,196,104,196*scaleFactor,104*scaleFactor,72,12);
                Write (x, 104, tempstr);
                if (!(i % BONUSSOUNDLEAPS))
                {
                    SD_PlaySound (DSPISTOL);
                    VW_WaitVBL (VBLPAUSE);
                }
                if(!usedoublebuffering || !(i % (PAR_AMOUNT / 50))) VW_UpdateScreen ();
                while(SD_SoundPlaying ())
                    BJ_Breathe ();
                if (IN_CheckAck ())
                    goto done;
            }

            VW_UpdateScreen ();
            
            SD_PlaySound (DSBAREXP);
            while (SD_SoundPlaying ())
                BJ_Breathe ();
        }
        
        VW_WaitVBL (VBLWAIT);

        //
        // KILL RATIO
        //
        ratio = kr;
        for (i = 0; i <= ratio; i++)
        {
            itoa (i, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
            VL_MemToScreenScaledCoord (source,320,200,232,50,232*scaleFactor,50*scaleFactor,36,12);
            Write (x, 50, tempstr);
            if (!(i % STATSSOUNDLEAPS))
            {
                SD_PlaySound (DSPISTOL);
                VW_WaitVBL (VBLPAUSE);
            }
            if(!usedoublebuffering || !(i & 1)) VW_UpdateScreen ();
            while (SD_SoundPlaying ())
                BJ_Breathe ();

            if (IN_CheckAck ())
                goto done;
        }
        if (ratio >= 100)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            bonus += PERCENT100AMT;
            ltoa (bonus, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
                VL_MemToScreenScaledCoord (source,320,200,196,104,196*scaleFactor,104*scaleFactor,72,12);
            Write (x, 104, tempstr);
            VW_UpdateScreen ();
            SD_PlaySound (DSBAREXP);
        }
        else if (!ratio)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            SD_PlaySound (DSBAREXP);
        }
        else
        {
            SD_PlaySound (DSBAREXP);
        }

        VW_UpdateScreen ();
        while (SD_SoundPlaying ())
            BJ_Breathe ();
        
        //
        // TREASURE RATIO
        //
        ratio = tr;
        for (i = 0; i <= ratio; i++)
        {
            itoa (i, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
            VL_MemToScreenScaledCoord (source,320,200,232,68,232*scaleFactor,68*scaleFactor,36,12);
            Write (x, 68, tempstr);
            if (!(i % STATSSOUNDLEAPS))
            {
                SD_PlaySound (DSPISTOL);
                VW_WaitVBL (VBLPAUSE);
            }
            if(!usedoublebuffering || !(i & 1)) VW_UpdateScreen ();
            while (SD_SoundPlaying ())
                BJ_Breathe ();
            if (IN_CheckAck ())
                goto done;
        }
        if (ratio >= 100)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            bonus += PERCENT100AMT;
            ltoa (bonus, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
                VL_MemToScreenScaledCoord (source,320,200,196,104,196*scaleFactor,104*scaleFactor,72,12);
            Write (x, 104, tempstr);
            VW_UpdateScreen ();
            SD_PlaySound (DSBAREXP);
        }
        else if (!ratio)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            SD_PlaySound (DSBAREXP);
        }
        else
        {
            SD_PlaySound (DSBAREXP);
        }
        VW_UpdateScreen ();
        while (SD_SoundPlaying ())
            BJ_Breathe ();

        //
        // SECRET RATIO
        //
        ratio = sr;
        for (i = 0; i <= ratio; i++)
        {
            itoa (i, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
            VL_MemToScreenScaledCoord (source,320,200,232,86,232*scaleFactor,86*scaleFactor,36,12);
            Write (x, 86, tempstr);
            if (!(i % STATSSOUNDLEAPS))
            {
                SD_PlaySound (DSPISTOL);
                VW_WaitVBL (VBLPAUSE);
            }
            if(!usedoublebuffering || !(i & 1)) VW_UpdateScreen ();
            while (SD_SoundPlaying ())
                BJ_Breathe ();

            if (IN_CheckAck ())
                goto done;
        }
        if (ratio >= 100)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            bonus += PERCENT100AMT;
            ltoa (bonus, tempstr, 10);
            x = RATIOXX - (int) strlen(tempstr) * 11;
                VL_MemToScreenScaledCoord (source,320,200,196,104,196*scaleFactor,104*scaleFactor,72,12);
            Write (x, 104, tempstr);
            VW_UpdateScreen ();
            SD_PlaySound (DSBAREXP);
        }
        else if (!ratio)
        {
            VW_WaitVBL (VBLWAIT);
            SD_StopSound ();
            SD_PlaySound (DSBAREXP);
        }
        else
        {
            SD_PlaySound (DSBAREXP);
        }
        VW_UpdateScreen ();
        while (SD_SoundPlaying ())
            BJ_Breathe ();

        //
        // JUMP STRAIGHT HERE IF KEY PRESSED
        //
done:		
        VL_MemToScreenScaledCoord (source,320,200,232,50,232*scaleFactor,50*scaleFactor,36,12);
        VL_MemToScreenScaledCoord (source,320,200,232,68,232*scaleFactor,68*scaleFactor,36,12);
        VL_MemToScreenScaledCoord (source,320,200,232,86,232*scaleFactor,86*scaleFactor,36,12);
        itoa (kr, tempstr, 10);
        x = RATIOXX - (int) strlen(tempstr) * 11;
        Write (x, 50, tempstr);

        itoa (tr, tempstr, 10);
        x = RATIOXX - (int) strlen(tempstr) * 11;
        Write (x, 68, tempstr);

        itoa (sr, tempstr, 10);
        x = RATIOXX - (int) strlen(tempstr) * 11;
        Write (x, 86, tempstr);
        
        bonus = (int32_t) timeleft *PAR_AMOUNT +
            (PERCENT100AMT * (kr >= 100)) +
            (PERCENT100AMT * (sr >= 100)) + (PERCENT100AMT * (tr >= 100));

        GivePoints (bonus);
        ltoa (bonus, tempstr, 10);
        x = RATIOXX - (int) strlen(tempstr) * 11;
        VL_MemToScreenScaledCoord (source,320,200,196,104,196*scaleFactor,104*scaleFactor,72,12);
        Write (x, 104, tempstr);

        //
        // SAVE RATIO INFORMATION FOR ENDGAME
        //
        LevelRatios[mapon].kill = kr;
        LevelRatios[mapon].secret = sr;
        LevelRatios[mapon].treasure = tr;
        LevelRatios[mapon].time = min * 60 + sec;
    
    VW_UpdateScreen ();

    lastBreathTime = GetTimeCount();
    IN_StartAck ();
    while (!IN_CheckAck ())
        BJ_Breathe ();

//
// done
//
    VW_FadeOut ();
    SD_PlaySound (DSWPNUP);
    
    UnCacheLump(LEVELEND_LUMP_START,LEVELEND_LUMP_END);
    UnCacheLump(INTERMISSION_LUMP_START,INTERMISSION_LUMP_END);
    UNCACHEGRCHUNK (BACKDROPPIC);
    UNCACHEGRCHUNK(picnum+STARTPICS); // LEVEL
}



//==========================================================================


/*
=================
=
= PreloadGraphics
=
= Fill the cache up
=
=================
*/

boolean
PreloadUpdate (unsigned current, unsigned total)
{
    unsigned w = WindowW - scaleFactor * 10;

    VWB_BarScaledCoord (WindowX + scaleFactor * 5, WindowY + WindowH - scaleFactor * 3,
        w, scaleFactor * 2, BLACK);
    w = ((int32_t) w * current) / total;
    if (w)
    {
        VWB_BarScaledCoord (WindowX + scaleFactor * 5, WindowY + WindowH - scaleFactor * 3,
            w, scaleFactor * 2, 0x37);       //SECONDCOLOR);
        VWB_BarScaledCoord (WindowX + scaleFactor * 5, WindowY + WindowH - scaleFactor * 3,
            w - scaleFactor * 1, scaleFactor * 1, 0x32);

    }
    VW_UpdateScreen ();
//      if (LastScan == sc_Escape)
//      {
//              IN_ClearKeysDown();
//              return(true);
//      }
//      else
    return (false);
}

void
PreloadGraphics (void)
{
    ClearSplitVWB ();           // set up for double buffering in split screen
    
    CA_CacheGrChunk (ENTERINGPIC);
    VWB_BarScaledCoord (0, 0, screenWidth, screenHeight - scaleFactor * (STATUSLINES - 1), 0x00);
    VWB_DrawPic (108,2,ENTERINGPIC);

    WindowX = (screenWidth - scaleFactor*224)/2;
    WindowY = (screenHeight - scaleFactor*(STATUSLINES+48))/2;
    WindowW = scaleFactor * 28 * 8;
    WindowH = scaleFactor * 48;

    VW_UpdateScreen ();
    VW_FadeIn ();

//      PM_Preload (PreloadUpdate);
    PreloadUpdate (10, 10);
    IN_UserInput (70);
    VW_FadeOut ();
    
    UNCACHEGRCHUNK (ENTERINGPIC);
    VW_UpdateScreen ();
}


//==========================================================================

/*
==================
=
= DrawHighScores
=
==================
*/

void DrawHighScores (void)
{
    char buffer[16];
    char buffer1[5];
    word i;
    HighScore *s;
    
    CA_CacheGrChunk (HIGHSCORESPIC);
    CA_CacheGrChunk (STARTFONT);
    CA_CacheGrChunk (LEVELPIC);
    CA_CacheGrChunk (SCOREPIC);
    CA_CacheGrChunk (NAMEPIC);
    CacheLump (MESSAGE_LUMP_START, MESSAGE_LUMP_END);

    ClearMScreen();
    
    VWB_DrawPic(76,24,HIGHSCORESPIC);
    VWB_DrawPic (28, 60, NAMEPIC);
    VWB_DrawPic (160, 60, LEVELPIC);
    VWB_DrawPic (224, 60, SCOREPIC);

    fontnumber = 0;
    SETFONTCOLOR (0xb6, 0xb6);

    for (i = 0, s = Scores; i < MaxScores; i++, s++)
    {
        PrintY = 76 + (16 * i);

        //
        // name
        //
        PrintX = 4 * 8;
        //US_Print (s->name);
        LSWrite (PrintX, PrintY, s->name);

        //
        // level
        //
        itoa (s->completed, buffer, 10);
        //for (str = buffer; *str; str++)
        //    *str = *str + (129 - '0');  // Used fixed-width numbers (129...)
        //USL_MeasureString (buffer, &w, &h);
        PrintX = (22 * 8)-12;
        itoa (s->episode + 1, buffer1, 10);
        itoa (s->completed, buffer, 10);
        LSWrite(PrintX, PrintY, "E");
        LSWrite(PrintX+=8, PrintY, buffer1);
        LSWrite(PrintX+=8, PrintY, "M");
        LSWrite(PrintX+=8, PrintY, buffer);

        //
        // score
        //
        itoa (s->score, buffer, 10);
        //for (str = buffer; *str; str++)
        //    *str = *str + (129 - '0');  // Used fixed-width numbers (129...)
        //USL_MeasureString (buffer, &w, &h);
        PrintX = (34 * 6)+22;
        LSWrite(PrintX, PrintY, buffer);
    }

    VW_UpdateScreen ();
    
    UNCACHEGRCHUNK (HIGHSCORESPIC);
    UNCACHEGRCHUNK (NAMEPIC);
    UNCACHEGRCHUNK (LEVELPIC);
    UNCACHEGRCHUNK (SCOREPIC);
    UnCacheLump (MESSAGE_LUMP_START, MESSAGE_LUMP_END);
}

//===========================================================================


/*
=======================
=
= CheckHighScore
=
=======================
*/
int lastScorePosition = 0;
void DrawViewScoreChunk(int which)
{
    CA_CacheGrChunk(BACKDROPPIC);
    byte* source = grsegs[BACKDROPPIC];
    VL_MemToScreenScaledCoord (source, 320, 200, 32, 76 + (16 * lastScorePosition) - 1, 32*scaleFactor, (76 + (16 * lastScorePosition) - 1)*scaleFactor, 124,12);
}

void
CheckHighScore (int32_t score, word other)
{
    word i, j;
    int n;
    HighScore myscore;

    strcpy (myscore.name, "");
    myscore.score = score;
    myscore.episode = gamestate.episode;
    myscore.completed = other;

    for (i = 0, n = -1; i < MaxScores; i++)
    {
        if ((myscore.score > Scores[i].score)
            || ((myscore.score == Scores[i].score) && (myscore.completed > Scores[i].completed)))
        {
            for (j = MaxScores; --j > i;)
                Scores[j] = Scores[j - 1];
            Scores[i] = myscore;
            n = i;
            break;
        }
    }

#ifdef SPEAR
    StartCPMusic (XAWARD_MUS);
#else
    //StartCPMusic (ROSTER_MUS);
#endif
    DrawHighScores ();

    VW_FadeIn ();

    if (n != -1)
    {
        //
        // got a high score
        //
        PrintY = 76 + (16 * n);
        PrintX = 4 * 8;
        backcolor = BORDCOLOR;
        fontcolor = 15;
        lastScorePosition = n;
        US_LineInput (PrintX, PrintY, Scores[n].name, 0, true, MaxHighName, 100, DrawViewScoreChunk);
    }
    else
    {
        IN_ClearKeysDown ();
        IN_UserInput (500);
    }

}


#ifndef UPLOAD
#ifndef SPEAR
#ifndef JAPAN
////////////////////////////////////////////////////////
//
// NON-SHAREWARE NOTICE
//
////////////////////////////////////////////////////////
void
NonShareware (void)
{
    VW_FadeOut ();

    ClearMScreen ();

    CA_CacheGrChunk (STARTFONT + 1);
    fontnumber = 1;

    SETFONTCOLOR (READHCOLOR, BKGDCOLOR);
    PrintX = 110;
    PrintY = 15;

#ifdef SPANISH
    US_Print ("Atencion");
#else
    US_Print ("Attention");
#endif

    SETFONTCOLOR (HIGHLIGHT, BKGDCOLOR);
    WindowX = PrintX = 40;
    PrintY = 60;
#ifdef SPANISH
    US_Print ("Este juego NO es gratis y\n");
    US_Print ("NO es Shareware; favor de\n");
    US_Print ("no distribuirlo.\n\n");
#else
    US_Print ("This game is NOT shareware.\n");
    US_Print ("Please do not distribute it.\n");
    US_Print ("Thanks.\n\n");
#endif
    US_Print ("        Id Software\n");

    VW_UpdateScreen ();
    VW_FadeIn ();
    IN_Ack ();
}
#endif
#endif
#endif

#ifdef SPEAR
#ifndef GOODTIMES
#ifndef SPEARDEMO
////////////////////////////////////////////////////////
//
// COPY PROTECTION FOR FormGen
//
////////////////////////////////////////////////////////
char CopyProFailedStrs[][100] = {
    STR_COPY1,
    STR_COPY2,

    STR_COPY3,
    STR_COPY4,

    STR_COPY5,
    STR_COPY6,

    STR_COPY7,
    STR_COPY8,

    STR_COPY9,
    "",

    STR_COPY10,
    STR_COPY11,

    STR_COPY12,
    "",

    STR_COPY13,
    "",

    STR_COPY14,
    ""
};

char BackDoorStrs[5][16] = {
    "a spoon?",
    "bite me!",
    "joshua",
    "pelt",
    "snoops"
};

char GoodBoyStrs[10][40] = {
    "...is the CORRECT ANSWER!",
    "",

    "Consider yourself bitten, sir.",
    "",

    "Greetings Professor Falken, would you",
    "like to play Spear of Destiny?",

    "Do you have any gold spray paint?",
    "",

    "I wish I had a 21\" monitor...",
    ""
};

char bossstrs[4][24] = {
    "DEATH KNIGHT",
    "BARNACLE WILHELM",
    "UBERMUTANTUBER MUTANT",
    "TRANS GROSSE"
};

char WordStr[5][20] = {
    "New Game",
    "Sound...F4",
    "Control...F6",
    "Change View...F5",
    "Quit...F10"
};

char WordCorrect[5][2] = { "3", "4", "4", "5", "5" };

char MemberStr[10][40] = {
    STR_COPY15,
    "",

    STR_COPY16,
    "",

    STR_COPY17,
    STR_COPY18,

    STR_COPY19,
    STR_COPY20,

    STR_COPY21,
    STR_COPY22
};

char MemberCorrect[5][24] = {
    "adrian carmack",
    "john carmackjohn romero",
    "tom hall",
    "jay wilbur",
    "kevin cloud"
};

char DosMessages[9][80] = {
    STR_NOPE1,
    STR_NOPE2,
    STR_NOPE3,
    STR_NOPE4,
    STR_NOPE5,
    STR_NOPE6,
    STR_NOPE7,
    STR_NOPE8,
    STR_NOPE9
};

char MiscTitle[4][20] = {
    "BLOOD TEST",
    "STRAIGHT-LACED",
    "QUITE SHAPELY",
    "I AM WHAT I AMMO"
};

char MiscStr[12][40] = {
    STR_MISC1,
    STR_MISC2,
    "",

    STR_MISC3,
    STR_MISC4,
    "",

    STR_MISC5,
    STR_MISC6,
    "",

    STR_MISC7,
    STR_MISC8,
    STR_MISC9
};

char MiscCorrect[4][5] = { "ss", "8", STR_STAR, "45" };


int
BackDoor (char *s)
{
    for (int i = 0; i < 5; i++)
    {
        if (!strcasecmp (s, BackDoorStrs[i]))
        {
            SETFONTCOLOR (14, 15);
            fontnumber = 0;
            PrintY = 175;
            VWB_DrawPic (0, 20 * 8, COPYPROTBOXPIC);
            US_CPrint (GoodBoyStrs[i * 2]);
            US_CPrint (GoodBoyStrs[i * 2 + 1]);
            VW_UpdateScreen ();
            return 1;
        }
    }

    return 0;
}


void
CopyProtection (void)
{
#define TYPEBOX_Y       177
#define TYPEBOX_BKGD    0x9c
#define PRINTCOLOR      HIGHLIGHT

    unsigned i;
    int match, whichboss, bossnum, attempt, whichline;
    int enemypicked[4] = { 0, 0, 0, 0 };
    int bosses[4] = { BOSSPIC1PIC, BOSSPIC2PIC, BOSSPIC3PIC, BOSSPIC4PIC };
    int whichpicked[4] = { 0, 0, 0, 0 };
    int whichone, quiztype, whichmem, whichword;
    int memberpicked[5] = { 0, 0, 0, 0, 0 };
    int wordpicked[5] = { 0, 0, 0, 0, 0 };

    char inputbuffer[20];
    char message[80];

    enum
    {
        debriefing,
        checkmanual,
        staffquiz,
        miscquiz,

        totaltypes
    };



    attempt = 0;
    VW_FadeOut ();
    CA_CacheGrChunk (C_BACKDROPPIC);
    CacheLump (COPYPROT_LUMP_START, COPYPROT_LUMP_END);
    CA_CacheGrChunk (STARTFONT + 1);
    CA_LoadAllSounds ();
    StartCPMusic (COPYPRO_MUS);
    US_InitRndT (true);

    while (attempt < 3)
    {
        fontnumber = 1;
        SETFONTCOLOR (PRINTCOLOR - 2, 15);
        VWB_DrawPic (0, 0, C_BACKDROPPIC);
        VWB_DrawPic (0, 0, COPYPROTTOPPIC);
        VWB_DrawPic (0, 20 * 8, COPYPROTBOXPIC);
        WindowX = WindowY = 0;
        WindowW = 320;
        WindowH = 200;
        PrintY = 65;

        quiztype = US_RndT () % totaltypes;
        switch (quiztype)
        {
            //
            // BOSSES QUIZ
            //
            case debriefing:
            {
                PrintX = 0;
                US_Print (STR_DEBRIEF);
                SETFONTCOLOR (PRINTCOLOR, 15);

                while (enemypicked[whichboss = US_RndT () & 3]);
                enemypicked[whichboss] = 1;
                bossnum = bosses[whichboss];
                VWB_DrawPic (128, 60, bossnum);
                fontnumber = 0;
                PrintY = 130;
                US_CPrint (STR_ENEMY1 "\n");
                US_CPrint (STR_ENEMY2 "\n\n");

                VW_UpdateScreen ();
                VW_FadeIn ();

                PrintX = 100;
                fontcolor = 15;
                backcolor = TYPEBOX_BKGD;
                inputbuffer[0] = 0;
                PrintY = TYPEBOX_Y;
                fontnumber = 1;
                US_LineInput (PrintX, PrintY, inputbuffer, 0, true, 20, 100);

                match = 0;
                size_t inputlen = strlen(inputbuffer);
                if(inputlen > 3)
                {
                    size_t bosslen = strlen(bossstrs[whichboss]);
                    for (i = 0; i < bosslen; i++)
                    {
                        if (!strncasecmp (inputbuffer, bossstrs[whichboss] + i, inputlen))
                        {
                            match = 1;
                            break;
                        }
                    }
                }

                match += BackDoor (inputbuffer);
                break;
            }

            //
            // MANUAL CHECK
            //
            case checkmanual:
            {
                while (wordpicked[whichword = US_RndT () % 5]);
                wordpicked[whichword] = 1;
                US_CPrint (STR_CHECKMAN);
                SETFONTCOLOR (PRINTCOLOR, 15);
                PrintY += 25;
                US_CPrint (STR_MAN1);
                US_CPrint (STR_MAN2);
                sprintf(message, STR_MAN3 " \"%s\" " STR_MAN4, WordStr[whichword]);
                US_CPrint (message);
                VW_UpdateScreen ();
                VW_FadeIn ();

                PrintX = 146;
                fontcolor = 15;
                backcolor = TYPEBOX_BKGD;
                inputbuffer[0] = 0;
                PrintY = TYPEBOX_Y;
                US_LineInput (PrintX, PrintY, inputbuffer, 0, true, 6, 100);

                match = 1 - (strcasecmp (inputbuffer, WordCorrect[whichword]) != 0);
                match += BackDoor (inputbuffer);
                break;
            }

            //
            // STAFF QUIZ
            //
            case staffquiz:
            {
                while (memberpicked[whichmem = US_RndT () % 5]);
                memberpicked[whichmem] = 1;
                US_CPrint (STR_ID1);
                SETFONTCOLOR (PRINTCOLOR, 15);
                PrintY += 25;
                US_CPrint (MemberStr[whichmem * 2]);
                US_CPrint (MemberStr[whichmem * 2 + 1]);
                VW_UpdateScreen ();
                VW_FadeIn ();

                PrintX = 100;
                fontcolor = 15;
                backcolor = TYPEBOX_BKGD;
                inputbuffer[0] = 0;
                PrintY = TYPEBOX_Y;
                US_LineInput (PrintX, PrintY, inputbuffer, 0, true, 20, 120);

                match = 0;
                size_t inputlen = strlen(inputbuffer);
                if(inputlen > 2)
                {
                    size_t memberlen = strlen(MemberCorrect[whichmem]);
                    for (i = 0; i < memberlen; i++)
                    {
                        if (!strncasecmp (inputbuffer, MemberCorrect[whichmem] + i, inputlen))
                        {
                            match = 1;
                            break;
                        }
                    }
                }

                match += BackDoor (inputbuffer);
                break;
            }

            //
            // MISCELLANEOUS QUESTIONS
            //
            case miscquiz:
            {
                while (whichpicked[whichone = US_RndT () & 3]);
                whichpicked[whichone] = 1;
                US_CPrint (MiscTitle[whichone]);
                SETFONTCOLOR (PRINTCOLOR, 15);
                PrintY += 25;
                US_CPrint (MiscStr[whichone * 3]);
                US_CPrint (MiscStr[whichone * 3 + 1]);
                US_CPrint (MiscStr[whichone * 3 + 2]);
                VW_UpdateScreen ();
                VW_FadeIn ();

                PrintX = 146;
                fontcolor = 15;
                backcolor = TYPEBOX_BKGD;
                inputbuffer[0] = 0;
                PrintY = TYPEBOX_Y;
                US_LineInput (PrintX, PrintY, inputbuffer, 0, true, 6, 100);

                match = 1 - (strcasecmp (inputbuffer, MiscCorrect[whichone]) != 0);
                match += BackDoor (inputbuffer);
                break;
            }
        }

        //
        // IF NO MATCH, WE'VE GOT A (MINOR) PROBLEM!
        //

        if (!match)
        {
            whichline = 2 * (US_RndT () % 9);
            SETFONTCOLOR (14, 15);
            fontnumber = 0;
            PrintY = 175;
            VWB_DrawPic (0, 20 * 8, COPYPROTBOXPIC);
            US_CPrint (CopyProFailedStrs[whichline]);
            US_CPrint (CopyProFailedStrs[whichline + 1]);

            VW_UpdateScreen ();
            SD_PlaySound (NOWAYSND);
            IN_UserInput (TickBase * 6);
            VW_FadeOut ();
            attempt++;
        }
        else
        {
            int start;

            SD_PlaySound (BONUS1UPSND);
            SD_WaitSoundDone ();
            UNCACHEGRCHUNK (STARTFONT + 1);
            UNCACHEGRCHUNK (C_BACKDROPPIC);
            UnCacheLump (COPYPROT_LUMP_START, COPYPROT_LUMP_END);

            switch (SoundMode)
            {
                case sdm_Off:
                    return;
                case sdm_PC:
                    start = STARTPCSOUNDS;
                    break;
                case sdm_AdLib:
                    start = STARTADLIBSOUNDS;
            }

/*                        for (i=0;i<NUMSOUNDS;i++,start++)
                                MM_FreePtr ((memptr *)&audiosegs[start]); */
            return;
        }
    }

    ClearMemory ();
    ShutdownId ();

    printf ("%s\n", DosMessages[US_RndT () % 9]);
    exit (1);
}

#endif // SPEARDEMO
#endif // GOODTIMES
#endif // SPEAR
//===========================================================================
